#(ie. use with rpm --rebuild):
#
#	--with debug	Compile with debugging code
#
# enable build with debugging code: will _not_ strip away any debugging code,
# will _add_ -g3 to CFLAGS, will _add_ --enable-maintainer-mode to
# configure.

#we use python2 here
%global __python %{__python2}

# "fix" underlinking:
%define _disable_ld_no_undefined 1

%define build_debug 0
%define build_test 0
%define build_oqgraph 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_debug: %{expand: %%define build_debug 1}}
%{?_with_test: %{expand: %%define build_test 1}}
%{?_without_test: %global build_test 0}
%{?_with_oqgraph: %{expand: %%define build_oqgraph 1}}
%{?_without_oqgraph: %global build_oqgraph 0}

%ifarch %mips %arm %ix86 x86_64 aarch64
%bcond_with java
%else
%bcond_with java
%endif

%if %{build_debug}
# disable build root strip policy
%define __spec_install_post %{_libdir}/rpm/brp-compress || :

# This gives extra debuggin and huge binaries
%{expand:%%define optflags %{optflags} %([ ! $DEBUG ] && echo '-g3')}
%endif

%if %{build_debug}
%define build_debug 1
%endif

%if %{build_test}
%define build_test 1
%endif

%if %{build_oqgraph}
%define build_oqgraph 1
%endif

%define major 3
%define libname %mklibname mariadb %{major}
%define develname %mklibname -d mariadb

%define mariadbdmajor 19
%define libmariadbembedded %mklibname mariadbd %{mariadbdmajor}
%define libmariadbembedded_devel %mklibname -d mariadb-embedded

%define muser	mysql

# rule out some useless autodeps in the test suite
%global __requires_exclude perl\\(th|perl\\(lib|perl\\(mtr|perl\\(My
%global __provides_exclude perl\\(th|perl\\(lib|perl\\(mtr|perl\\(My

Summary:	A very fast and reliable SQL database engine
Name:		mariadb
Version:	10.6.5
Release:	%mkrel 1
Group:		Databases
License:	GPLv2 with exceptions
URL:		http://mariadb.org/
Source0:	https://downloads.mariadb.org/interstitial/mariadb-%{version}/source/mariadb-%{version}.tar.gz
Source3:	my.cnf
#Source10:	mysql.tmpfiles.d
#Source11:	mysqld.service
Source12:	mysqld-prepare-db-dir

# Skip some tests failing on BS
Source40:	mga-skipped-tests-base.list

# config files to load plugins, note these files are processed by expand, line 678
Source50:	auth_pam.cnf
Source51:	auth_socket.cnf
Source52:	ha_archive.cnf
Source53:	ha_blackhole.cnf
Source54:	ha_cassandra.cnf
Source55:	ha_connect.cnf
Source56:	ha_federatedx.cnf
Source57:	handlersocket.cnf
Source58:	ha_oqgraph.cnf
Source59:	ha_sequence.cnf
Source60:	ha_sphinx.cnf
Source61:	ha_spider.cnf
Source62:	locales.cnf
Source63:	metadata_lock_info.cnf
Source64:	query_cache_info.cnf
Source65:	query_response_time.cnf
Source66:	disks.cnf
Source67:	ha_mroonga.cnf
Source68:	sql_errlog.cnf
Source69:	feedback.cnf
Source70:	ha_innodb.cnf
Source71:	server_audit.cnf
Source72:	auth_gssapi.cnf

Source100:  mysqld
# the following patches are rediffed from the mysql-5.5 src.rpm to mariadb-5.5
# fedora patches

# mandriva patches
Patch101:	mariadb-5.5-logrotate.patch
Patch106:	mariadb-5.5-hotcopy.patch
Patch107:	mariadb-5.5-mysql_install_db-quiet.patch
#remove setting ownership of system install files
Patch108:	mysql_install_db.patch

#Requires(post):	systemd >= %{systemd_required_version}
Requires(post):	rpm-helper
Requires(preun): rpm-helper
Requires(post): %{name}-common = %{version}-%{release}
Requires(preun): %{name}-common = %{version}-%{release}
Requires(post): %{name}-client = %{version}-%{release}
Requires(preun): %{name}-client = %{version}-%{release}
Requires(postun): %{name}-common = %{version}-%{release}
Requires(postun): %{name}-client = %{version}-%{release}
Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-core = %{version}-%{release}
Requires:	%{name}-client = %{version}-%{release}
Provides:	mysql = %{version}-%{release}
BuildRequires:	bison
BuildRequires:	cmake
BuildRequires:	doxygen
BuildRequires:	glibc-devel
BuildRequires:	libaio-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtermcap-devel
BuildRequires:	mercurial
BuildRequires:	pkgconfig(libarchive)
BuildRequires:	pkgconfig(libevent)
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	wrap-devel
#BuildRequires:	systemtap
#BuildRequires:	systemtap-sdt-devel
BuildRequires:	texinfo
BuildRequires:	xfs-devel
BuildRequires:	pkgconfig(zlib)
BuildRequires:	libaio-devel
BuildRequires:	pam-devel
BuildConflicts:	edit-devel
BuildRequires:	pkgconfig(python3)
BuildRequires:	icu-devel
BuildRequires:	bzip2-devel
BuildRequires:	pkgconfig(odbc)
BuildRequires:	pkgconfig(libzstd)
BuildRequires:	pkgconfig(jemalloc)
%if %{build_oqgraph}
# required by oqgraph v3
BuildRequires:	boost-devel
BuildRequires:	judy-devel
%endif
%if %with java
# required by cassandra
#BuildRequires:	pkgconfig(thrift)
%endif
# external pcre, 10.0.9+
# https://bugs.mageia.org/show_bug.cgi?id=12665
BuildRequires:	pkgconfig(libpcre2-8)
BuildRequires:	pkgconfig(libpcre2-posix)
BuildRequires:	pkgconfig(liblz4)
BuildRequires:	pkgconfig(krb5)
BuildRequires:	libcrack-devel
BuildRequires:	lzma-devel
BuildRequires:	liblzo-devel
#BuildRequires:	pkgconfig(systemd)
BuildRequires:	glibc-devel
#BuildRequires:	cmake(msgpack)
BuildRequires:	pkgconfig(libzmq)

%description
The MariaDB software delivers a very fast, multi-threaded, multi-user, and
robust SQL (Structured Query Language) database server. MariaDB Server is
intended for mission-critical, heavy-load production systems as well as for
embedding into mass-deployed software.

The mariadb server is compiled with the following storage engines:

 - Aria Storage Engine
 - Archive Storage Engine
 - Blackhole Storage Engine
 - CSV Storage Engine
 - FederatedX Storage Engine (Federated replacement)
 - Heap Storage Engine
 - MyISAM Storage Engine
 - MyISAMMRG Storage Engine
 - Partition Storage Engine
 - Perfschema Storage Engine
 - Percona XtraDB Storage Engine (InnoDB replacement)

A multitude of storage engines and handlers are being provided in separate sub
packages such as:

%if %with java
mariadb-cassandra	- Cassandra Storage Engine
%endif
mariadb-feedback	- Feedback Storage Engine
mariadb-oqgraph		- Open Query GRAPH computation engine
mariadb-connect		- CONNECT handler
mariadb-sphinx		- Sphinx Storage Engine
mariadb-sequence	- Sequence Storage Engine
mariadb-spider		- Spider Storage Engine
mariadb-rocks			- RocksDB Storage Engine

The following extra storage engines are provided by the mariadb-extra package

 - handlersocket
 - query_cache_info

The following storage engines are provided in the mariadb-obsolete package

 - Federated Storage Engine

%package -n	mysql-MariaDB
Summary:	A MySQL drop-in replacement
Group:		System/Servers
Requires:	%{name}

%description -n	mysql-MariaDB
MariaDB is a complete MySQL drop-in replacement with additional fixes and
storage engines.

This package is used as a transitional virtual package, which requires
MariaDB so that people who used to use mysql can find it nicely.

%if %with java
%package	cassandra
Summary:	Cassandra Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	cassandra
The Cassandra Storage Engine allows access to data in a Cassandra cluster from
MariaDB.
%endif

%package	feedback
Summary:	Feedback storage engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	feedback
MariaDB feedback storage engine submits feedback about your mariadb server.
Results can be seen on http://mariadb.org/feedback_plugin/ .

%if %{build_oqgraph}
%package	oqgraph
Summary:	Open Query GRAPH computation engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	oqgraph
The Open Query GRAPH computation engine allows you to handle hierarchies
(tree structures) and complex graphs (nodes having many connections in
several directions).
%endif

%package	connect
Summary:	CONNECT handler
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	connect
The CONNECT handler enables MariaDB to access external local or remote data.
This is done by defining tables based on different data types, in particular
files of various format, data extracted from other products (such as Excel),
or data retrieved from the environment (for example DIR, WMI, and MAC tables).

This handler supports MariaDB virtual columns and also permits to define
“special” columns such as ROWID and FILEID.

%package	sphinx
Summary:	Sphinx Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Conflicts:	%{name}-common-core < %{version}-%{release}

%description	sphinx
SphinxSE is a storage engine that talks to searchd (Sphinx daemon) to enable
full text searching.

%package	mroonga
Summary:	Mroonga Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	mroonga
Mroonga is a storage engine for MySQL. It provides fast fulltext search feature
to all MySQL users. Mroonga was called Groonga storage engine.

%package	sequence
Summary:	Sequence Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	sequence
A Sequence engine allows the creation of ascending or descending sequences of
numbers with a given starting value, ending value and increment.

It creates completely virtual, ephemeral tables automatically when you need
them. There is no way to create a Sequence table explicitly. Nor are they ever
written to disk or create .frm files. They are read-only, transactional, and
support XA.

%package	spider
Summary:	Spider Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	spider
The Spider storage engine supports partitioning and xa transactions, and allows
tables of different MariaDB instances to be handled as if they were on the same
instance.

%ifarch %arm x86_64 aarch64
%package	rocks
Summary:	Rocks Storage Engine
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	rocks
MyRocks is an open source storage engine that was originally developed by
Facebook.

MyRocks has been extended by the MariaDB engineering team to be a pluggable
storage engine that you use in your MariaDB solutions. It works seamlessly
with MariaDB features. This openness in the storage layer allows you to use the
 right storage engine to optimize your usage requirements, which provides
 optimum performance. Community contributions are one of MariaDB’s greatest
 advantages over other databases. Under the lead of our developer Sergey
 Petrunia, MyRocks in MariaDB is constantly being merged with upstream MyRocks
 from Facebook.
%endif

%package	extra
Summary:	MariaDB extra storage engines
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	extra
This package provides various storage engines/handlers such as:

 - handlersocket
 - query_cache_info

%package	obsolete
Summary:	MariaDB obsolete storage engines
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}

%description	obsolete
MariaDB obsolete storage engines. Federated are being replaced by XtraDB and
FederatedX storage engines. These obsolete storage engines are provided in
case you need the vanilla mysql storage engines.

%package	core
Summary:	Server core binary
Group:		System/Servers
Requires:	%{name}-common-core >= %{version}-%{release}
Provides:	mysql-core = %{version}-%{release}

%description	core
Core mysqld server binary. For a full MariaDB database server, install
package 'mariadb'.

%package	common-core
Summary:	Common files required by core binary
Group:		System/Servers
Requires:	%{name}-common >= %{version}-%{release}
Provides:	mysql-common-core = %{version}-%{release}

%description	common-core
Common files minimally required by mysqld server binary.

%package	common
Summary:	Common files
Group:		System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(post): %{name}-client >= %{version}-%{release}
Requires(preun): %{name}-client >= %{version}-%{release}
Requires:	%{name}-client >= %{version}-%{release}
Requires:	perl(Term::ReadKey)
Requires: perl(DBD::MariaDB)
Provides:	mysql-common = %{version}-%{release}

%description	common
Common files for the MariaDB database server.

%package	client
Summary:	Client
Group:		Databases
Requires(post): %{libname} >= %{version}-%{release}
Requires(preun): %{libname} >= %{version}-%{release}
Requires:	%{libname} >= %{version}-%{release}
Requires:	%{name}-common >= %{version}-%{release}
Provides:	mysql-client = %{version}-%{release}

%description	client
This package contains the standard MariaDB clients.

%package	bench
Summary:	Benchmarks and test system
Group:		System/Servers
Requires(post): %{name}-client >= %{version}-%{release}
Requires(preun): %{name}-client >= %{version}-%{release}
Requires:	%{name}-client >= %{version}-%{release}
Recommends:	%{name} >= %{version}-%{release}
Provides:	mysql-bench = %{version}-%{release}

%description	bench
This package contains MariaDB benchmark scripts and data.

%package pam
Summary:	PAM authentication plugin
Group:	System/Servers
URL:	https://mariadb.com/kb/en/authentication-plugin-pam/
Requires:	%{name}

%description pam
The pam authentication plugin allows MariaDB to offload user authentication to
the system's Pluggable Authentication Module (PAM) framework.
%package -n	%{libname}
Summary:	Shared libraries
Group:		System/Libraries
Provides:	%{name}-shared-libs = %{version}-%{release}
Provides:	%{name}-shared = %{version}-%{release}

%description -n	%{libname}
This package contains the shared libraries (*.so*) which certain languages and
applications need to dynamically load and use MariaDB.

%package -n	%{develname}
Summary:	Development header files and libraries
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name}-common >= %{version}-%{release}
Requires:	%{name}-client >= %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	mysql-devel = %{version}-%{release}

%description -n	%{develname}
This package contains the development header files and libraries necessary to
develop MariaDB client applications.

%package -n 	%{libmariadbembedded}
Summary:	MariaDB as an embeddable library
Group:		System/Libraries
Provides:	%{name}-embedded = %{version}-%{release}

%description -n %{libmariadbembedded}
MariaDB is a multi-user, multi-threaded SQL database server. This
package contains a version of the MariaDB server that can be embedded
into a client application instead of running as a separate process.

The API is identical for the embedded MariaDB version and the client/server
version.

%package -n 	%{libmariadbembedded_devel}
Summary:	Development files for MySQL as an embeddable library
Group:		Development/Other
Requires:	%{libmariadbembedded} = %{version}-%{release}
Requires:	%{develname} = %{version}-%{release}
Provides:	%{name}-embedded-devel = %{version}-%{release}
Provides:	mysql-embedded-devel = %{version}-%{release}

%description -n %{libmariadbembedded_devel}
MariaDB is a multi-user, multi-threaded SQL database server. This
package contains files needed for developing and testing with
the embedded version of the MariaDB server.

The API is identical for the embedded MariaDB version and the client/server
version.


%prep
%setup -q hg
# no bundled pcre
rm -rf pcre

mkdir -p Mageia
cp %{SOURCE3} Mageia/my.cnf

# remove the sql_yacc.cc file so that bison will regenerate it properly, even if it's patched
rm -f sql/sql_yacc.cc

#no macos
rm -rf support-files/MacOSX

# lib64 fix
perl -pi -e "s|/usr/lib/|%{_libdir}/|g" Mageia/my.cnf

# antiborker
perl -pi -e "s|\@bindir\@|%{_bindir}|g" support-files/* scripts/*
perl -pi -e "s|\@sbindir\@|%{_sbindir}|g" support-files/* scripts/*
perl -pi -e "s|\@libexecdir\@|%{_sbindir}|g" support-files/* scripts/*
perl -pi -e "s|\@localstatedir\@|/var/lib/mysql|g" support-files/* scripts/*
perl -pi -e "s|^basedir=.*|basedir=%{_prefix}|g" support-files/* scripts/mysql_install_db*

# workaround for upstream bug #56342
rm -f mysql-test/t/ssl_8k_key-master.opt
rm -f mysql-test/t/file_contents.test

# skip some tests failing on BS
cat %{_sourcedir}/mga-skipped-tests-base.list | tee -a mysql-test/unstable-tests

%build

## MariaDB
%serverbuild
export CFLAGS="${CFLAGS:-%{optflags}} -O3 -fno-delete-null-pointer-checks"
export CXXFLAGS="${CXXFLAGS:-%{optflags}} -O3 -fno-delete-null-pointer-checks"
export LDFLAGS="%{ldflags} -O3 -lz"
export FFLAGS="${FFLAGS:-%{optflags}}"
export LC_ALL=C
#-DPLUGIN_INNOBASE=DYNAMIC \

%cmake \
	-DINSTALL_SBINDIR=sbin \
	-DMYSQL_DATADIR=/var/lib/mysql \
	-DINSTALL_SYSCONFDIR=%{_sysconfdir} \
	-DINSTALL_PLUGINDIR=%{_lib}/mysql/plugin \
	-DINSTALL_MANDIR=share/man \
	-DINSTALL_SHAREDIR=share/mysql \
	-DINSTALL_LIBDIR=%{_lib} \
	-DINSTALL_INCLUDEDIR=include/mysql \
	-DINSTALL_INFODIR=share/info \
	-DINSTALL_MYSQLDATADIR=/var/lib/mysql \
	-DINSTALL_MYSQLTESTDIR=share/mysql/mysql-test \
	-DINSTALL_SQLBENCHDIR=share/mysql \
	-DINSTALL_SUPPORTFILESDIR=share/mysql \
	-DINSTALL_MYSQLSHAREDIR=share/mysql \
	-DLZ4_LIBS=%{_libdir} \
	-Wno-deprecated \
	-DMYSQL_UNIX_ADDR=/var/lib/mysql/mysql.sock \
	-DWITH_READLINE=system \
	-DWITH_LIBEDIT=0 \
	-DWITH_LIBWRAP=1 \
	-DWITH_SSL=system \
	-DWITH_ZLIB=system \
	-DWITH_PCRE=system \
	-DWITH_PIC=1 \
	-DMYSQL_TCP_PORT=3306 \
	-DEXTRA_CHARSETS=all \
	-DENABLED_LOCAL_INFILE=1 \
	-DENABLE_DTRACE=0 \
	-DWITH_EMBEDDED_SERVER=1 \
	-DMYSQL_USER=%{muser} \
%if %{build_debug}
	-DWITH_DEBUG=1 \
%else
	-DWITH_DEBUG=0 \
%endif
	-DFEATURE_SET="community" \
	-DRPM=1 \
	-DCOMPILATION_COMMENT="PCLinuxOS MariaDB Server" \
	-DPLUGIN_ARIA=STATIC \
	-DPLUGIN_PARTITION=STATIC \
	-DPLUGIN_PERFSCHEMA=STATIC \
	-DPLUGIN_XTRADB=STATIC \
	-DPLUGIN_ARCHIVE=DYNAMIC \
	-DPLUGIN_AUDIT_NULL=DYNAMIC \
	-DPLUGIN_AUTH_0X0100=DYNAMIC \
	-DPLUGIN_AUTH_PAM=DYNAMIC \
	-DPLUGIN_AUTH_SOCKET=DYNAMIC \
	-DPLUGIN_AUTH_TEST_PLUGIN=DYNAMIC \
	-DPLUGIN_BLACKHOLE=DYNAMIC \
%if %with java
	-DPLUGIN_CASSANDRA=DYNAMIC \
%else
	-DPLUGIN_CASSANDRA=NO \
%endif
	-DPLUGIN_CONNECT=DYNAMIC \
	-DPLUGIN_DEBUG_KEY_MANAGEMENT=DYNAMIC \
	-DPLUGIN_DIALOG=DYNAMIC \
	-DPLUGIN_DIALOG_EXAMPLES=DYNAMIC \
	-DPLUGIN_FEDERATED=DYNAMIC \
	-DPLUGIN_FEDERATEDX=DYNAMIC \
	-DPLUGIN_FEEDBACK=DYNAMIC \
	-DPLUGIN_FILE_KEY_MANAGEMENT=DYNAMIC \
	-DPLUGIN_FTEXAMPLE=DYNAMIC \
	-DPLUGIN_HANDLERSOCKET=DYNAMIC \
	-DPLUGIN_LOCALES=DYNAMIC \
	-DPLUGIN_METADATA_LOCK_INFO=DYNAMIC \
	-DPLUGIN_MROONGA=DYNAMIC \
	-DPLUGIN_MYSQL_CLEAR_PASSWORD=DYNAMIC \
%if %{build_oqgraph}
	-DPLUGIN_OQGRAPH=DYNAMIC \
%else
	-DPLUGIN_OQGRAPH=NO \
%endif
	-DPLUGIN_QA_AUTH_CLIENT=DYNAMIC \
	-DPLUGIN_QA_AUTH_INTERFACE=DYNAMIC \
	-DPLUGIN_QA_AUTH_SERVER=DYNAMIC \
	-DPLUGIN_QUERY_CACHE_INFO=DYNAMIC \
	-DPLUGIN_QUERY_RESPONSE_TIME=DYNAMIC \
	-DPLUGIN_SEMISYNC_MASTER=DYNAMIC \
	-DPLUGIN_SEMISYNC_SLAVE=DYNAMIC \
	-DPLUGIN_SEQUENCE=DYNAMIC \
	-DPLUGIN_SERVER_AUDIT=DYNAMIC \
	-DPLUGIN_SIMPLE_PASSWORD_CHECK=DYNAMIC \
	-DPLUGIN_SPHINX=DYNAMIC \
	-DPLUGIN_SPIDER=DYNAMIC \
	-DPLUGIN_SQL_ERRLOG=DYNAMIC \
	-DPLUGIN_TEST_SQL_DISCOVERY=DYNAMIC \
	-DPLUGIN_WSREP_INFO=DYNAMIC \
	-DPLUGIN_DAEMON_EXAMPLE=NO \
	-DPLUGIN_EXAMPLE=NO \
	-DPLUGIN_EXAMPLE_KEY_MANAGEMENT=NO \
	-DPLUGIN_TOKUDB=NO \
	-DPYTHON_SHEBANG=%{__python2}

%cmake_build

%install
# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

%if %{build_debug}
export DONT_STRIP=1
%endif

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_var}/log/mysqld
install -d %{buildroot}/var/lib/mysql/{mysql,test}

%cmake_install

# exclude loaddata7 from being converted
export EXCLUDE_FROM_EOL_CONVERSION="std_data/loaddata7.dat"

# install configuration files
install -m0644 Mageia/my.cnf %{buildroot}%{_sysconfdir}/my.cnf

mkdir -p %{buildroot}/%{_sysconfdir}/rc.d/init.d
install -m 0755 %{SOURCE100} %{buildroot}/%{_sysconfdir}/rc.d/init.d/mysqld

# clean installed files first
rm -rf %{buildroot}%{_unitdir}

# don't use systemd way to create mysql user
rm -rf %{buildroot}%{_sysusersdir}/sysusers.conf

#install -m 0644 -D %{SOURCE10} %{buildroot}%{_tmpfilesdir}/mysql.conf
rm -rf %{buildroot}%{_tmpfilesdir}/tmpfiles.conf

#install -m 0644 -D %{SOURCE11} %{buildroot}%{_unitdir}/mysqld.service
install -m 0755 %{SOURCE12} %{buildroot}%{_sbindir}/mysqld-prepare-db-dir

# cleanup some config files
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/cassandra.cnf \
	%{buildroot}%{_sysconfdir}/my.cnf.d/connect.cnf \
	 %{buildroot}%{_sysconfdir}/my.cnf.d/oqgraph.cnf

# magic by anssi
pushd %{buildroot}%{_sysconfdir}/my.cnf.d
%{expand:%(for i in {50..72}; do echo "install -m 644 %%SOURCE$i ."; done)}
popd

%if ! %with java
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/ha_cassandra.cnf
%endif

%if ! %{build_oqgraph}
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/ha_oqgraph.cnf
%endif

#groonga
rm -f %{buildroot}%{_datadir}/groonga-normalizer-mysql/lgpl-2.0.txt
mv %{buildroot}%{_datadir}/groonga-normalizer-mysql %{buildroot}%{_datadir}/mysql
mv %{buildroot}%{_datadir}/groonga %{buildroot}%{_datadir}/mysql

# bork
mv %{buildroot}%{_datadir}/mysql/aclocal %{buildroot}%{_datadir}/aclocal

#pam
mv %{buildroot}/%{_lib}/security %{buildroot}/%{_libdir}/

pushd %{buildroot}%{_bindir}
	ln -sf mysqlcheck mysqlrepair
	ln -sf mysqlcheck mysqlanalyze
	ln -sf mysqlcheck mysqloptimize
popd

# nuke -Wl,--as-needed from the mysql_config file
perl -pi -e "s|^ldflags=.*|ldflags=\'-rdynamic\'|g" %{buildroot}%{_bindir}/mysql_config

# cmake generates some completely wacko references to -lprobes_mysql when
# building with dtrace support. Haven't found where to shut that off,
# so resort to this blunt instrument. While at it, let's not reference
# libmysqlclient_r anymore either.
sed -e 's/-lprobes_mysql//' -e 's/-lmysqlclient_r/-lmysqlclient/' \
	%{buildroot}%{_bindir}/mysql_config >mysql_config.tmp
cp -f mysql_config.tmp %{buildroot}%{_bindir}/mysql_config
chmod 755 %{buildroot}%{_bindir}/mysql_config
install -m 0755 -d %{buildroot}/var/lib/mysql

# missing header
#install -m0644 build/include/probes_mysql_dtrace.h %{buildroot}%{_includedir}/mysql/

# libmysqlclient_r is no more. Upstream tries to replace it with symlinks
# but that really doesn't work (wrong soname in particular). We'll keep
# just the devel libmysqlclient_r.so link, so that rebuilding without any
# source change is enough to get rid of dependency on libmysqlclient_r.
rm -f %{buildroot}%{_libdir}/libmysqlclient_r.so*
ln -s libmariadb.so %{buildroot}%{_libdir}/libmysqlclient_r.so

# remove static libs
rm -f %{buildroot}%{_libdir}/libmariadbclient.a
rm -f %{buildroot}%{_libdir}/libmysqlclient.a
rm -f %{buildroot}%{_libdir}/libmysqlclient_r.a
rm -f %{buildroot}%{_libdir}/libmysqld.a
rm -f %{buildroot}%{_libdir}/libmariadbd.a

# mysql-test includes one executable that doesn't belong under /usr/share,
# so move it and provide a symlink
mv %{buildroot}%{_datadir}/mysql/mysql-test/lib/My/SafeProcess/my_safe_process %{buildroot}%{_bindir}
ln -s %{_bindir}/my_safe_process %{buildroot}%{_datadir}/mysql/mysql-test/lib/My/SafeProcess/my_safe_process

# mysql client statically built against a local embedded library, pretty useless
rm -f %{buildroot}%{_bindir}/mariadb-embedded
rm -f %{buildroot}%{_bindir}/mysql_embedded
rm -f %{buildroot}%{_mandir}/man1/mariadb-embedded.1*
rm -f %{buildroot}%{_mandir}/man1/mysql_embedded.1*

# this command enables plugins, but needs ini file + configuration in my.cnf
# before executing... and oh yeah, mysql must be stopped... => useless
# however, apparently tests seem to want it, even thought they don't use it.
#rm -f %{buildroot}%{_bindir}/mysql_plugin
rm -f %{buildroot}%{_libdir}/mysql/plugin/daemon_example.ini

# no RHEL4 selinux files for us
rm -rf %{buildroot}%{_datadir}/mysql/SELinux
# no solaris files for us
rm -rf %{buildroot}%{_datadir}/mysql/solaris
# no init script for us
rm -f %{buildroot}%{_initrddir}/mysql
#rm -f %{buildroot}%{_initrddir}/mysqld


# house cleaning
rm -rf %{buildroot}%{_datadir}/info
rm -f %{buildroot}%{_bindir}/client_test
rm -f %{buildroot}%{_bindir}/maria_add_gis_sp.sql
rm -f %{buildroot}%{_bindir}/make_win_binary_distribution
rm -f %{buildroot}%{_bindir}/make_win_src_distribution
rm -f %{buildroot}%{_bindir}/test-connect-t
rm -f %{buildroot}%{_datadir}/mysql/binary-configure
rm -f %{buildroot}%{_datadir}/mysql/config.huge.ini
rm -f %{buildroot}%{_datadir}/mysql/config.medium.ini
rm -f %{buildroot}%{_datadir}/mysql/config.small.ini
rm -f %{buildroot}%{_datadir}/mysql/mysqld_multi.server
rm -f %{buildroot}%{_datadir}/mysql/mysql-log-rotate
rm -f %{buildroot}%{_datadir}/mysql/mysql.server
rm -f %{buildroot}%{_datadir}/mysql/ndb-config-2-node.ini
rm -f %{buildroot}%{_datadir}/mysql/binary-configure
rm -f %{buildroot}%{_mandir}/man1/galera_new_cluster.1*
rm -f %{buildroot}%{_mandir}/man1/galera_recovery.1*
rm -f %{buildroot}%{_mandir}/man1/make_win_bin_dist.1*
rm -f %{buildroot}%{_mandir}/man1/make_win_src_distribution.1*
rm -f %{buildroot}%{_mandir}/man1/mariadb-service-convert.1*
rm -rf %{buildroot}%{_mandir}/man3
rm -f %{buildroot}%{_datadir}/mysql/magic
rm -f %{buildroot}%{_sbindir}/rcmysql
rm -rf %{buildroot}%{_datadir}/mysql/policy
rm -rf %{buildroot}%{_datadir}/mysql/systemd
rm -f %{buildroot}%{_bindir}/mariadb-service-convert
rm -f %{buildroot}%{_bindir}/galera_new_cluster
rm -f %{buildroot}%{_bindir}/galera_recovery
rm -f %{buildroot}%{_datadir}/mysql/wsrep_notify
rm -f %{buildroot}%{_datadir}/mysql/mysql_test_db.sql
touch %{buildroot}%{_datadir}/mysql/mysql_test_db.sql
cp %{SOURCE72} %{buildroot}%{_sysconfdir}/my.cnf.d/auth_gssapi.cnf

#rocksdb is not available for i586
%ifarch %arm x86_64 aarch64
%else
rm -f %{buildroot}%{_sysconfdir}/my.cnf.d/rocksdb.cnf
rm -f %{buildroot}%{_libdir}/mysql/plugin/ha_rocksdb.so
rm -f %{buildroot}%{_bindir}/myrocks_hotbackup
rm -f %{buildroot}%{_bindir}/mariadb-ldb
rm -f %{buildroot}%{_bindir}/mysql_ldb
rm -f %{buildroot}%{_bindir}/sst_dump
rm -f %{buildroot}%{_mandir}/man1/mariadb-ldb.1*
rm -f %{buildroot}%{_mandir}/man1/mysql_ldb.1*
%endif


# no idea how to fix this
rm -rf %{buildroot}%{_prefix}/data
rm -rf %{buildroot}%{_prefix}/docs
rm -rf %{buildroot}%{_prefix}/scripts
rm -rf %{buildroot}%{_datadir}/doc
rm -rf %{buildroot}%{_sysconfdir}/init.d

rm -rf %{buildroot}/etc/columnstore/Columnstore.xml
rm -rf %{buildroot}/etc/columnstore/ErrorMessage.txt
rm -rf %{buildroot}/etc/columnstore/MessageFile.txt
rm -rf %{buildroot}/etc/columnstore/storagemanager.cnf
rm -rf %{buildroot}/etc/columnstore/storagemanager.cnf.example
rm -rf %{buildroot}/etc/my.cnf.d/columnstore.cnf
rm -rf %{buildroot}/etc/my.cnf.d/s3.cnf
 rm -rf %{buildroot}/usr/bin/DDLProc
 rm -rf %{buildroot}/usr/bin/DMLProc
 rm -rf %{buildroot}/usr/bin/ExeMgr
 rm -rf %{buildroot}/usr/bin/PrimProc
 rm -rf %{buildroot}/usr/bin/StorageManager
 rm -rf %{buildroot}/usr/bin/WriteEngineServer
 rm -rf %{buildroot}/usr/bin/aria_s3_copy
 rm -rf %{buildroot}/usr/bin/autoConfigure
 rm -rf %{buildroot}/usr/bin/clearShm
 rm -rf %{buildroot}/usr/bin/cleartablelock
 rm -rf %{buildroot}/usr/bin/columnstore-post-install
 rm -rf %{buildroot}/usr/bin/columnstore-pre-uninstall
 rm -rf %{buildroot}/usr/bin/columnstoreDBWrite
 rm -rf %{buildroot}/usr/bin/columnstoreSyslogSetup.sh
 rm -rf %{buildroot}/usr/bin/columnstore_run.sh
 rm -rf %{buildroot}/usr/bin/colxml
 rm -rf %{buildroot}/usr/bin/controllernode
 rm -rf %{buildroot}/usr/bin/cpimport
 rm -rf %{buildroot}/usr/bin/cpimport.bin
 rm -rf %{buildroot}/usr/bin/cplogger
 rm -rf %{buildroot}/usr/bin/cskeys
 rm -rf %{buildroot}/usr/bin/cspasswd
 rm -rf %{buildroot}/usr/bin/dbbuilder
 rm -rf %{buildroot}/usr/bin/dbrmctl
 rm -rf %{buildroot}/usr/bin/ddlcleanup
 rm -rf %{buildroot}/usr/bin/editem
 rm -rf %{buildroot}/usr/bin/idbmeminfo
 rm -rf %{buildroot}/usr/bin/load_brm
 rm -rf %{buildroot}/usr/bin/mariadb-columnstore-start.sh
 rm -rf %{buildroot}/usr/bin/mariadb-columnstore-stop.sh
 rm -rf %{buildroot}/usr/bin/mcs-loadbrm.py
 rm -rf %{buildroot}/usr/bin/mcs-savebrm.py
 rm -rf %{buildroot}/usr/bin/mcs-stop-controllernode.sh
 rm -rf %{buildroot}/usr/bin/mcsGetConfig
 rm -rf %{buildroot}/usr/bin/mcsRebuildEM
 rm -rf %{buildroot}/usr/bin/mcsSetConfig
 rm -rf %{buildroot}/usr/bin/mycnfUpgrade
 rm -rf %{buildroot}/usr/bin/post-mysql-install
 rm -rf %{buildroot}/usr/bin/post-mysqld-install
 rm -rf %{buildroot}/usr/bin/reset_locks
 rm -rf %{buildroot}/usr/bin/rollback
 rm -rf %{buildroot}/usr/bin/save_brm
 rm -rf %{buildroot}/usr/bin/smcat
 rm -rf %{buildroot}/usr/bin/smls
 rm -rf %{buildroot}/usr/bin/smput
 rm -rf %{buildroot}/usr/bin/smrm
 rm -rf %{buildroot}/usr/bin/testS3Connection
 rm -rf %{buildroot}/usr/bin/viewtablelock
 rm -rf %{buildroot}/usr/bin/workernode
rm -rf %{buildroot}/usr/lib64/libbatchloader.so
rm -rf %{buildroot}/usr/lib64/libbrm.so
rm -rf %{buildroot}/usr/lib64/libcacheutils.so
rm -rf %{buildroot}/usr/lib64/libcloudio.so
rm -rf %{buildroot}/usr/lib64/libcommon.so
rm -rf %{buildroot}/usr/lib64/libcompress.so
rm -rf %{buildroot}/usr/lib64/libconfigcpp.so
rm -rf %{buildroot}/usr/lib64/libdataconvert.so
rm -rf %{buildroot}/usr/lib64/libdatatypes.so
rm -rf %{buildroot}/usr/lib64/libdbbc.a
rm -rf %{buildroot}/usr/lib64/libddlcleanuputil.so
rm -rf %{buildroot}/usr/lib64/libddlpackage.so
rm -rf %{buildroot}/usr/lib64/libddlpackageproc.so
rm -rf %{buildroot}/usr/lib64/libdmlpackage.so
rm -rf %{buildroot}/usr/lib64/libdmlpackageproc.so
rm -rf %{buildroot}/usr/lib64/libexecplan.so
rm -rf %{buildroot}/usr/lib64/libfuncexp.so
rm -rf %{buildroot}/usr/lib64/libidbboot.a
rm -rf %{buildroot}/usr/lib64/libidbdatafile.so
rm -rf %{buildroot}/usr/lib64/libjoblist.so
rm -rf %{buildroot}/usr/lib64/libjoiner.so
rm -rf %{buildroot}/usr/lib64/liblibmysql_client.so
rm -rf %{buildroot}/usr/lib64/libloggingcpp.so
rm -rf %{buildroot}/usr/lib64/libmarias3.so
rm -rf %{buildroot}/usr/lib64/libmessageqcpp.so
rm -rf %{buildroot}/usr/lib64/liboamcpp.so
rm -rf %{buildroot}/usr/lib64/libprocessor.a
rm -rf %{buildroot}/usr/lib64/libquerystats.so
rm -rf %{buildroot}/usr/lib64/libquerytele.so
rm -rf %{buildroot}/usr/lib64/libregr.so
rm -rf %{buildroot}/usr/lib64/librowgroup.so
rm -rf %{buildroot}/usr/lib64/librwlock.so
rm -rf %{buildroot}/usr/lib64/libstoragemanager.so
rm -rf %{buildroot}/usr/lib64/libthreadpool.so
rm -rf %{buildroot}/usr/lib64/libthrift.so
rm -rf %{buildroot}/usr/lib64/libudfsdk.so
rm -rf %{buildroot}/usr/lib64/libwe_xml.a
rm -rf %{buildroot}/usr/lib64/libwindowfunction.so
rm -rf %{buildroot}/usr/lib64/libwriteengine.so
rm -rf %{buildroot}/usr/lib64/libwriteengineclient.so
rm -rf %{buildroot}/usr/lib64/libwriteengineredistribute.so
rm -rf %{buildroot}/usr/lib64/mysql/plugin/ha_columnstore.so
rm -rf %{buildroot}/usr/lib64/mysql/plugin/ha_s3.so
rm -rf %{buildroot}/usr/lib64/mysql/plugin/libregr_mysql.so
rm -rf %{buildroot}/usr/lib64/mysql/plugin/libudf_mysql.so
rm -rf %{buildroot}/usr/sbin/install_mcs_mysql.sh
rm -rf %{buildroot}/usr/share/columnstore/calremoveuserpriority.sql
rm -rf %{buildroot}/usr/share/columnstore/calsetuserpriority.sql
rm -rf %{buildroot}/usr/share/columnstore/calshowprocesslist.sql
rm -rf %{buildroot}/usr/share/columnstore/columnstoreAlias
rm -rf %{buildroot}/usr/share/columnstore/columnstoreLogRotate
rm -rf %{buildroot}/usr/share/columnstore/columnstoreSyslog
rm -rf %{buildroot}/usr/share/columnstore/columnstoreSyslog-ng
rm -rf %{buildroot}/usr/share/columnstore/columnstoreSyslog7
rm -rf %{buildroot}/usr/share/columnstore/columnstore_info.sql
rm -rf %{buildroot}/usr/share/columnstore/dumpcat_mysql.sql
rm -rf %{buildroot}/usr/share/columnstore/gitversionEngine
rm -rf %{buildroot}/usr/share/columnstore/mariadb-columnstore.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-controllernode.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-ddlproc.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-dmlproc.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-exemgr.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-loadbrm.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-primproc.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-storagemanager.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-workernode.service
rm -rf %{buildroot}/usr/share/columnstore/mcs-writeengineserver.service
rm -rf %{buildroot}/usr/share/columnstore/myCnf-exclude-args.text
rm -rf %{buildroot}/usr/share/columnstore/myCnf-include-args.text
rm -rf %{buildroot}/usr/share/columnstore/releasenum
rm -rf %{buildroot}/usr/share/columnstore/syscatalog_mysql.sql
rm -rf %{buildroot}/usr/share/mysql/JavaWrappers.jar
rm -rf %{buildroot}/usr/share/mysql/JdbcInterface.jar
rm -rf %{buildroot}/usr/share/mysql/Mongo2.jar
rm -rf %{buildroot}/usr/share/mysql/Mongo3.jar
rm -rf %{buildroot}/var/lib/columnstore/local/module


cat > README.pclos <<EOF

NOTE: MariaDB is installed without root password, it is recommended to set the
root password with the following command as soon as possible:

 # mysql_secure_installation
 press enter at each question except the new root password.

The initscript used to start mysql has been reverted to use the one shipped
by MariaDB. This means the following changes:

 * The generation of the initial system mysql database is now done when mysql
   is started from the initscript and only if the /var/lib/mysql/mysql
   directory is empty (mysql_install_db). Previousely this was quite hidden and
   silently done at (rpm) install time. As a consequence to this change you may
   have to perform some manual tasks to upgrade the mysql system database and
   such. So, doing something like this might help you:

   systemctl stop mysqld.service
   TMPDIR=/var/tmp mysql_install_db
   mysql_upgrade --skip-write-binlog

The cluster functionalities (ndb) has been deactivated and will be removed in
future mysql versions. Oracle has a new product named mysql-cluster that
replaces the cluster functionalities.

The mysql-common-core package ships with a default /etc/my.cnf file that is
based on the my-medium.cnf file that comes with the source code.

If you need time zone data, run the following command after install:
mysql_tzinfo_to_sql /usr/share/zoneinfo | mysql -D mysql
EOF

%pre
# enable plugins
if [ -f %{_sysconfdir}/my.cnf ]; then
	perl -pi -e "s|^#plugin-load|plugin-load|g" %{_sysconfdir}/my.cnf
	perl -pi -e "s|^#federated|federated|g" %{_sysconfdir}/my.cnf
	# switch to federatedx provider
	perl -pi -e "s|;ha_federated\.so$|;ha_federatedx\.so|g" %{_sysconfdir}/my.cnf
fi

%pre common
# delete the mysql group if no mysql user is found, before adding the user
if [ -z "`getent passwd %{muser}`" ] && ! [ -z "`getent group %{muser}`" ]; then
	%{_sbindir}/groupdel %{muser} 2> /dev/null || :
fi

%_pre_useradd %{muser} /var/lib/mysql /bin/bash

%post
#%_tmpfilescreate mysql
%_post_service mysqld

%preun
%_preun_service mysqld

%postun
%_postun_service mysqld

%pre common-core
# enable plugins
if [ -f %{_sysconfdir}/my.cnf ]; then
	perl -pi -e "s|^#plugin-load|plugin-load|g" %{_sysconfdir}/my.cnf
	perl -pi -e "s|^#federated|federated|g" %{_sysconfdir}/my.cnf
	# switch to federatedx provider
	perl -pi -e "s|;ha_federated\.so$|;ha_federatedx\.so|g" %{_sysconfdir}/my.cnf
fi

%files
%doc README.pclos
%config(noreplace) %{_sysconfdir}/rc.d/init.d/mysqld
%config(noreplace) %{_sysconfdir}/logrotate.d/mysql
%config(noreplace) %{_sysconfdir}/my.cnf.d/auth_gssapi.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/auth_socket.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/cracklib_password_check.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/disks.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/enable_encryption.preset
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_archive.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_blackhole.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_federatedx.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/locales.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/metadata_lock_info.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/query_response_time.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/server_audit.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/sql_errlog.cnf

%{_libdir}/mysql/plugin/auth_ed25519.so
%{_libdir}/mysql/plugin/auth_gssapi_client.so
%{_libdir}/mysql/plugin/auth_gssapi.so
%{_libdir}/mysql/plugin/auth_socket.so
%{_libdir}/mysql/plugin/caching_sha2_password.so
%{_libdir}/mysql/plugin/cracklib_password_check.so
%{_libdir}/mysql/plugin/debug_key_management.so
%{_libdir}/mysql/plugin/disks.so
%{_libdir}/mysql/plugin/file_key_management.so
%{_libdir}/mysql/plugin/ha_archive.so
%{_libdir}/mysql/plugin/ha_blackhole.so
%{_libdir}/mysql/plugin/ha_federatedx.so
%{_libdir}/mysql/plugin/locales.so
%{_libdir}/mysql/plugin/metadata_lock_info.so
%{_libdir}/mysql/plugin/query_response_time.so
%{_libdir}/mysql/plugin/server_audit.so
%{_libdir}/mysql/plugin/sha256_password.so
%{_libdir}/mysql/plugin/simple_password_check.so
%{_libdir}/mysql/plugin/sql_errlog.so
%{_libdir}/mysql/plugin/test_sql_service.so
%{_libdir}/mysql/plugin/type_mysql_json.so
%{_libdir}/mysql/plugin/wsrep_info.so
%{_sbindir}/mysqld-prepare-db-dir


%files -n mysql-MariaDB

%files obsolete
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_innodb.cnf
%{_libdir}/mysql/plugin/ha_federated.so

%if %with java
%files cassandra
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_cassandra.cnf
%{_libdir}/mysql/plugin/ha_cassandra.so
%endif

%files feedback
%config(noreplace) %{_sysconfdir}/my.cnf.d/feedback.cnf
%{_libdir}/mysql/plugin/feedback.so

%if %{build_oqgraph}
%files oqgraph
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_oqgraph.cnf
%{_libdir}/mysql/plugin/ha_oqgraph.so
%endif

%files connect
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_connect.cnf
%{_libdir}/mysql/plugin/ha_connect.so

%files sphinx
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_sphinx.cnf
%{_libdir}/mysql/plugin/ha_sphinx.so

%ifarch %arm x86_64 aarch64
%files rocks
%config(noreplace) %{_sysconfdir}/my.cnf.d/rocksdb.cnf
%{_libdir}/mysql/plugin/ha_rocksdb.so
%{_bindir}/myrocks_hotbackup
%{_bindir}/mariadb-ldb
%{_bindir}/mysql_ldb
%{_bindir}/sst_dump
%{_mandir}/man1/mariadb-ldb.1*
%{_mandir}/man1/mysql_ldb.1*
%endif

%files mroonga
%doc %{_datadir}/mysql/groonga/COPYING
%doc %{_datadir}/mysql/groonga-normalizer-mysql/README.md
%doc %{_datadir}/mysql/groonga/README.md
%doc %{_datadir}/mysql/mroonga/AUTHORS
%doc %{_datadir}/mysql/mroonga/COPYING
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_mroonga.cnf
%{_libdir}/mysql/plugin/ha_mroonga.so
%{_datadir}/mysql/mroonga/install.sql
%{_datadir}/mysql/mroonga/uninstall.sql

%files sequence
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_sequence.cnf
%{_libdir}/mysql/plugin/ha_sequence.so

%files spider
%config(noreplace) %{_sysconfdir}/my.cnf.d/ha_spider.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/spider.cnf
%{_libdir}/mysql/plugin/ha_spider.so

%files extra
%config(noreplace) %{_sysconfdir}/my.cnf.d/handlersocket.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/query_cache_info.cnf
%{_libdir}/mysql/plugin/handlersocket.so
# new optional functionality
%{_libdir}/mysql/plugin/query_cache_info.so

%files client
%config(noreplace) %{_sysconfdir}/my.cnf.d/client.cnf
%config(noreplace) %{_sysconfdir}/my.cnf.d/mysql-clients.cnf
%{_bindir}/mariabackup
%{_bindir}/mariadb
%{_bindir}/mariadb-access
%{_bindir}/mariadb-admin
%{_bindir}/mariadb-binlog
%{_bindir}/mariadb-check
%{_bindir}/mariadb-conv
%{_bindir}/mariadb-dump
%{_bindir}/mariadb-dumpslow
%{_bindir}/mariadb-find-rows
%{_bindir}/mariadb-import
%{_bindir}/mariadb-show
%{_bindir}/mariadb-slap
%{_bindir}/mariadb-waitpid
%{_bindir}/mbstream
%{_bindir}/msql2mysql
%{_bindir}/mysql
%{_bindir}/mysqlaccess
%{_bindir}/mysqladmin
%{_bindir}/mysqlanalyze
%{_bindir}/mysqlbinlog
%{_bindir}/mysqlcheck
%{_bindir}/mysqldump
%{_bindir}/mysqldumpslow
%{_bindir}/mysql_find_rows
%{_bindir}/mysqlimport
%{_bindir}/mysqloptimize
%{_bindir}/mysqlrepair
%{_bindir}/mysqlshow
%{_bindir}/mysqlslap
%{_bindir}/mysql_waitpid
%{_mandir}/man1/aria_s3_copy.1*
%{_mandir}/man1/mariabackup.1*
%{_mandir}/man1/mariadb.1*
%{_mandir}/man1/mariadb-access.1*
%{_mandir}/man1/mariadb-admin.1*
%{_mandir}/man1/mariadb-binlog.1*
%{_mandir}/man1/mariadb-check.1*
%{_mandir}/man1/mariadb_config.1.*
%{_mandir}/man1/mariadb-conv.1.*
%{_mandir}/man1/mariadb-dump.1*
%{_mandir}/man1/mariadb-dumpslow.1*
%{_mandir}/man1/mariadb-find-rows.1*
%{_mandir}/man1/mariadb-import.1*
%{_mandir}/man1/mariadb-show.1*
%{_mandir}/man1/mariadb-waitpid.1*
%{_mandir}/man1/mbstream.1*
%{_mandir}/man1/msql2mysql.1*
%{_mandir}/man1/myisam_ftdump.1*
%{_mandir}/man1/myrocks_hotbackup.1.*
%{_mandir}/man1/mysql.1*
%{_mandir}/man1/mysqlaccess.1*
%{_mandir}/man1/mysqladmin.1*
%{_mandir}/man1/mysqlbinlog.1*
%{_mandir}/man1/mysqlcheck.1*
%{_mandir}/man1/mysqldump.1*
%{_mandir}/man1/mysqldumpslow.1*
%{_mandir}/man1/mysql_find_rows.1*
%{_mandir}/man1/mysqlimport.1*
%{_mandir}/man1/mysqlshow.1*
%{_mandir}/man1/mysql_waitpid.1*
%{_mandir}/man1/mytop.1.*
# libmysqlclient plugins
%{_libdir}/mysql/plugin/dialog.so
%{_libdir}/mysql/plugin/mysql_clear_password.so
%{_libdir}/mysql/plugin/client_ed25519.so

%files bench
%doc build/sql-bench/README
%{_bindir}/my_safe_process
%{_bindir}/mariadb-client-test
%{_bindir}/mysql_client_test
%{_datadir}/mysql/sql-bench
%{_mandir}/man1/my_safe_process.1*
%{_mandir}/man1/mariadb-client-test.1*
%{_mandir}/man1/mysql_client_test.1*
%{_mandir}/man1/mysql-stress-test.pl.1*
%{_mandir}/man1/mariadb-test.1*
%{_mandir}/man1/mysqltest.1*
%{_mandir}/man1/mysql-test-run.pl.1*
%{_libdir}/mysql/plugin/adt_null.so
%{_libdir}/mysql/plugin/auth_0x0100.so
%{_libdir}/mysql/plugin/auth_test_plugin.so
%{_libdir}/mysql/plugin/dialog_examples.so
%{_libdir}/mysql/plugin/func_test.so
%{_libdir}/mysql/plugin/ha_test_sql_discovery.so
%{_libdir}/mysql/plugin/mypluglib.so
%{_libdir}/mysql/plugin/qa_auth_client.so
%{_libdir}/mysql/plugin/qa_auth_interface.so
%{_libdir}/mysql/plugin/qa_auth_server.so
%{_libdir}/mysql/plugin/type_test.so
%{_libdir}/mysql/plugin/test_versioning.so
%attr(-,%{muser},%{muser}) %{_datadir}/mysql/mysql-test
%attr(0755,%{muser},%{muser}) %dir /var/lib/mysql/test

%files core
%{_sbindir}/mariadbd
%{_sbindir}/mysqld

%files common-core
%config(noreplace) %{_sysconfdir}/my.cnf.d/server.cnf
%config(noreplace) %{_sysconfdir}/my.cnf
%dir %{_datadir}/mysql
%{_datadir}/mysql/english
%{_datadir}/mysql/charsets

%files common
%doc README.md COPYING
%dir %{_sysconfdir}/my.cnf.d
%dir %{_libdir}/mysql/plugin
%{_bindir}/aria_chk
%{_bindir}/aria_dump_log
%{_bindir}/aria_ftdump
%{_bindir}/aria_pack
%{_bindir}/aria_read_log
%{_bindir}/innochecksum
%{_bindir}/myisamchk
%{_bindir}/myisam_ftdump
%{_bindir}/myisamlog
%{_bindir}/myisampack
%{_bindir}/my_print_defaults
%{_bindir}/mariabackup
%{_bindir}/mariadb-backup
%{_bindir}/mariadb-convert-table-format
%{_bindir}/mysql_convert_table_format
%{_bindir}/mariadbd-multi
%{_bindir}/mysqld_multi
%{_bindir}/mariadbd-safe
%{_bindir}/mysqld_safe
%{_bindir}/mariadbd-safe-helper
%{_bindir}/mysqld_safe_helper
%{_bindir}/mariadb-fix-extensions
%{_bindir}/mysql_fix_extensions
%{_bindir}/mariadb-hotcopy
%{_bindir}/mysqlhotcopy
%{_bindir}/mariadb-install-db
%{_bindir}/mysql_install_db
%{_bindir}/mariadb-plugin
%{_bindir}/mysql_plugin
%{_bindir}/mariadb-secure-installation
%{_bindir}/mysql_secure_installation
%{_bindir}/mariadb-setpermission
%{_bindir}/mysql_setpermission
%{_bindir}/mariadb-test
%{_bindir}/mysqltest
%{_bindir}/mariadb-tzinfo-to-sql
%{_bindir}/mysql_tzinfo_to_sql
%{_bindir}/mariadb-upgrade
%{_bindir}/mysql_upgrade
%{_bindir}/mytop
%{_bindir}/perror
%{_bindir}/replace
%{_bindir}/resolveip
%{_bindir}/resolve_stack_dump
%{_bindir}/wsrep_sst_common
%{_bindir}/wsrep_sst_mariabackup
%{_bindir}/wsrep_sst_mysqldump
%{_bindir}/wsrep_sst_rsync
%{_bindir}/wsrep_sst_rsync_wan
%attr(0755,%{muser},%{muser}) %dir /var/lib/mysql
%attr(0755,%{muser},%{muser}) %dir /var/lib/mysql/mysql
%attr(0755,%{muser},%{muser}) %dir %{_var}/log/mysqld
%{_datadir}/mysql/*.cnf
%{_datadir}/mysql/fill_help_tables.sql
%{_datadir}/mysql/mysql_performance_tables.sql
%{_datadir}/mysql/mysql_system_tables.sql
%{_datadir}/mysql/mysql_system_tables_data.sql
%{_datadir}/mysql/mysql_test_db.sql
%{_datadir}/mysql/mysql_test_data_timezone.sql
%{_datadir}/mysql/mysql_sys_schema.sql
%{_datadir}/mysql/errmsg-utf8.txt
%{_datadir}/mysql/maria_add_gis_sp_bootstrap.sql
%{_datadir}/mysql/maria_add_gis_sp.sql
%{_datadir}/mysql/czech
%{_datadir}/mysql/danish
%{_datadir}/mysql/dutch
%{_datadir}/mysql/estonian
%{_datadir}/mysql/french
%{_datadir}/mysql/german
%{_datadir}/mysql/greek
%{_datadir}/mysql/hindi
%{_datadir}/mysql/hungarian
%{_datadir}/mysql/italian
%{_datadir}/mysql/japanese
%{_datadir}/mysql/korean
%{_datadir}/mysql/norwegian
%{_datadir}/mysql/norwegian-ny
%{_datadir}/mysql/polish
%{_datadir}/mysql/portuguese
%{_datadir}/mysql/romanian
%{_datadir}/mysql/russian
%{_datadir}/mysql/serbian
%{_datadir}/mysql/slovak
%{_datadir}/mysql/spanish
%{_datadir}/mysql/swedish
%{_datadir}/mysql/ukrainian
%{_mandir}/man1/aria_chk.1*
%{_mandir}/man1/aria_dump_log.1*
%{_mandir}/man1/aria_ftdump.1*
%{_mandir}/man1/aria_pack.1*
%{_mandir}/man1/aria_read_log.1*
%{_mandir}/man1/innochecksum.1*
%{_mandir}/man1/mariadb-backup.1*
%{_mandir}/man1/myisamchk.1*
%{_mandir}/man1/myisamlog.1*
%{_mandir}/man1/myisampack.1*
%{_mandir}/man1/my_print_defaults.1*
%{_mandir}/man1/mariadb-convert-table-format.1*
%{_mandir}/man1/mysql_convert_table_format.1*
%{_mandir}/man1/mariadbd-multi.1*
%{_mandir}/man1/mysqld_multi.1*
%{_mandir}/man1/mariadbd-safe.1*
%{_mandir}/man1/mysqld_safe.1*
%{_mandir}/man1/mariadbd-safe-helper.1*
%{_mandir}/man1/mysqld_safe_helper.1*
%{_mandir}/man1/mariadb-fix-extensions.1*
%{_mandir}/man1/mysql_fix_extensions.1*
%{_mandir}/man1/mariadb-hotcopy.1*
%{_mandir}/man1/mysqlhotcopy.1*
%{_mandir}/man1/mariadb-install-db.1*
%{_mandir}/man1/mysql_install_db.1*
%{_mandir}/man1/mariadb-plugin.1*
%{_mandir}/man1/mysql_plugin.1*
%{_mandir}/man1/mariadb-secure-installation.1*
%{_mandir}/man1/mysql_secure_installation.1*
%{_mandir}/man1/mysql.server.1*
%{_mandir}/man1/mariadb-setpermission.1*
%{_mandir}/man1/mysql_setpermission.1*
%{_mandir}/man1/mariadb-slap.1*
%{_mandir}/man1/mysqlslap.1*
%{_mandir}/man1/mariadb-tzinfo-to-sql.1*
%{_mandir}/man1/mysql_tzinfo_to_sql.1*
%{_mandir}/man1/mariadb-upgrade.1*
%{_mandir}/man1/mysql_upgrade.1*
%{_mandir}/man1/perror.1*
%{_mandir}/man1/replace.1*
%{_mandir}/man1/resolveip.1*
%{_mandir}/man1/resolve_stack_dump.1*
%{_mandir}/man8/mysqld.8*
%{_mandir}/man8/mariadb*
%{_mandir}/man1/wsrep_*.1*

%files pam
%config(noreplace) %{_sysconfdir}/my.cnf.d/auth_pam.cnf
%config(noreplace) %{_sysconfdir}/security/user_map.conf
%{_libdir}/security/pam_user_map.so
%dir %{_libdir}/mysql/plugin/auth_pam_tool_dir/
%{_libdir}/mysql/plugin/auth_pam_tool_dir/auth_pam_tool
%{_libdir}/mysql/plugin/auth_pam_v1.so
%{_libdir}/mysql/plugin/auth_pam.so

%files -n %{libname}
%{_libdir}/libmariadb.so.%{major}*


%files -n %{develname}
%doc INSTALL-SOURCE
%{_bindir}/mariadb-config
%{_bindir}/mariadb_config
%{_bindir}/mysql_config
%{_libdir}/libmariadb.so
%{_libdir}/libmysqlclient_r.so
%{_libdir}/libmysqlclient.so
%{_libdir}/pkgconfig/mariadb.pc
%{_libdir}/pkgconfig/libmariadb.pc
%dir %{_includedir}/mysql
%dir %{_includedir}/mysql/mariadb
%dir %{_includedir}/mysql/mysql
%dir %{_includedir}/mysql/server
%dir %{_includedir}/mysql/server/mysql/psi
%dir %{_includedir}/mysql/server/private/atomic
%{_includedir}/mysql/*.h
%{_includedir}/mysql/mariadb/*.h
%{_includedir}/mysql/mysql/*.h
%{_includedir}/mysql/server/*.h
%{_includedir}/mysql/server/mysql/*.h
%{_includedir}/mysql/server/mysql/psi/*.h
%{_includedir}/mysql/server/private/*.h
%{_includedir}/mysql/server/private/atomic/*.h
%{_mandir}/man1/mysql_config.1*
%{_datadir}/aclocal/mysql.m4
# mysqlservices library is static, because it doesn't contain any code
# itself, and is meant to be statically linked to all plugins.
%{_libdir}/libmysqlservices.a

%files -n %{libmariadbembedded}
%doc COPYING
%{_libdir}/libmariadbd.so.%{mariadbdmajor}*

%files -n %{libmariadbembedded_devel}
%{_libdir}/libmariadbd.so
%{_libdir}/libmysqld.so
%{_bindir}/mariadb-client-test-embedded
%{_bindir}/mysql_client_test_embedded
%{_bindir}/mariadb-test-embedded
%{_bindir}/mysqltest_embedded
%{_mandir}/man1/mariadb-client-test-embedded.1*
%{_mandir}/man1/mysql_client_test_embedded.1*
%{_mandir}/man1/mariadb-test-embedded.1*
%{_mandir}/man1/mysqltest_embedded.1*


%changelog
